Index: framework/source/class/qx/renderer/color/ColorObject.js
===================================================================
--- framework/source/class/qx/renderer/color/ColorObject.js	(Revision 6514)
+++ framework/source/class/qx/renderer/color/ColorObject.js	(Arbeitskopie)
@@ -107,7 +107,7 @@
      *
      * @type member
      * @param vTheme {var} TODOC
-     * @return {void}
+     * @return {void} 
      * @throws TODOC
      */
     _updateTheme : function(vTheme)
@@ -125,12 +125,12 @@
      * TODOC
      *
      * @type member
-     * @return {void}
+     * @return {void} 
      */
     _applyThemedValue : function()
     {
       var vTheme = qx.manager.object.ColorManager.getInstance().getColorTheme();
-      var vRgb = vTheme.colors[this._value];
+      var vRgb = vTheme.getValueByName(this._value);
 
       if (vRgb)
       {
@@ -139,7 +139,7 @@
         this._blue = vRgb[2];
       }
 
-      this._style = vTheme._compiledColors[this._value];
+      this._style = vTheme.getStyleByName(this._value);
       this._hex = null;
     },
 
@@ -148,7 +148,7 @@
      * TODOC
      *
      * @type member
-     * @return {void}
+     * @return {void} 
      */
     _syncObjects : function()
     {
@@ -163,7 +163,7 @@
      *
      * @type member
      * @param vValue {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     setValue : function(vValue)
     {
@@ -185,7 +185,7 @@
      *
      * @type member
      * @param vObject {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     add : function(vObject) {
       this._dependentObjects[vObject.toHashCode()] = vObject;
@@ -197,7 +197,7 @@
      *
      * @type member
      * @param vObject {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     remove : function(vObject) {
       delete this._dependentObjects[vObject.toHashCode()];
Index: framework/source/class/qx/manager/object/ColorManager.js
===================================================================
--- framework/source/class/qx/manager/object/ColorManager.js	(Revision 6514)
+++ framework/source/class/qx/manager/object/ColorManager.js	(Arbeitskopie)
@@ -73,7 +73,8 @@
     {
       _legacy   : true,
       type      : "object",
-      allowNull : false
+      allowNull : false,
+      instance  : "qx.renderer.theme.ColorTheme"
     }
   },
 
@@ -99,14 +100,14 @@
      *
      * @type member
      * @param vThemeClass {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     registerColorTheme : function(vThemeClass)
     {
-      this._colorThemes[vThemeClass.name] = vThemeClass;
+      this._colorThemes[vThemeClass.classname] = vThemeClass;
 
-      if (vThemeClass.name == qx.core.Setting.get("qx.colorTheme")) {
-        this.setColorTheme(vThemeClass);
+      if (vThemeClass.classname == qx.core.Setting.get("qx.colorTheme")) {
+        this.setColorTheme(vThemeClass.getInstance());
       }
     },
 
@@ -116,10 +117,10 @@
      *
      * @type member
      * @param vId {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     setColorThemeById : function(vId) {
-      this.setColorTheme(this._colorThemes[vId]);
+      this.setColorTheme(this._colorThemes[vId].getInstance());
     },
 
 
@@ -136,7 +137,7 @@
      *
      * @type member
      * @param oObject {Object} TODOC
-     * @return {void}
+     * @return {void} 
      */
     add : function(oObject)
     {
@@ -155,7 +156,7 @@
      *
      * @type member
      * @param oObject {Object} TODOC
-     * @return {void}
+     * @return {void} 
      */
     remove : function(oObject)
     {
@@ -209,7 +210,7 @@
      */
     _modifyColorTheme : function(propValue, propOldValue, propData)
     {
-      this._compileTheme(propValue);
+      propValue.compile();
 
       for (var i in this._dependentObjects) {
         this._dependentObjects[i]._updateTheme(propValue);
@@ -223,35 +224,6 @@
 
     /*
     ---------------------------------------------------------------------------
-      PROTECTED METHODS
-    ---------------------------------------------------------------------------
-    */
-
-    /**
-     * TODOC
-     *
-     * @type member
-     * @return {void}
-     */
-    _compileTheme : function(theme)
-    {
-      if (theme._compiledColors) {
-        return;
-      }
-
-      var colors = theme.colors;
-      var compiled = theme._compiledColors = {};
-
-      for (var name in qx.renderer.color.Color.themedNames) {
-        compiled[name] = colors[name] ? qx.renderer.color.Color.rgb2style.apply(this, colors[name]) : name;
-      }
-    },
-
-
-
-
-    /*
-    ---------------------------------------------------------------------------
       UTILITY
     ---------------------------------------------------------------------------
     */
@@ -263,7 +235,7 @@
      * @param vParent {var} TODOC
      * @param xCor {var} TODOC
      * @param yCor {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     createThemeList : function(vParent, xCor, yCor)
     {
@@ -275,8 +247,8 @@
 
       for (var vId in vThemes)
       {
-        var vObj = vThemes[vId];
-        var vButton = new qx.ui.form.Button(vPrefix + vObj.title, vIcon);
+        var vObj = vThemes[vId].getInstance();
+        var vButton = new qx.ui.form.Button(vPrefix + vObj.getTitle(), vIcon);
 
         vButton.setLocation(xCor, yCor);
         vButton.addEventListener(vEvent, new Function("qx.manager.object.ColorManager.getInstance().setColorThemeById('" + vId + "')"));
@@ -331,7 +303,14 @@
   *****************************************************************************
   */
 
-  settings : {
+  settings :
+  {
+    /*
+    ---------------------------------------------------------------------------
+      DEFAULT SETTINGS
+    ---------------------------------------------------------------------------
+    */
+
     "qx.colorTheme" : "qx.theme.color.WindowsRoyale"
   }
 });
Index: framework/source/class/qx/manager/object/AppearanceManager.js
===================================================================
--- framework/source/class/qx/manager/object/AppearanceManager.js	(Revision 6514)
+++ framework/source/class/qx/manager/object/AppearanceManager.js	(Arbeitskopie)
@@ -46,7 +46,7 @@
     qx.manager.object.ObjectManager.call(this);
 
     // Themes
-    this.__themes = {};
+    this._appearanceThemes = {};
   },
 
 
@@ -71,7 +71,8 @@
     {
       _legacy   : true,
       type      : "object",
-      allowNull : false
+      allowNull : false,
+      instance  : "qx.renderer.theme.AppearanceTheme"
     }
   },
 
@@ -98,14 +99,14 @@
      *
      * @type member
      * @param vThemeClass {qx.renderer.theme.AppearanceTheme} TODOC
-     * @return {void}
+     * @return {void} 
      */
     registerAppearanceTheme : function(vThemeClass)
     {
-      this.__themes[vThemeClass.name] = vThemeClass;
+      this._appearanceThemes[vThemeClass.classname] = vThemeClass;
 
-      if (vThemeClass.name == qx.core.Setting.get("qx.appearanceTheme")) {
-        this.setAppearanceTheme(vThemeClass);
+      if (vThemeClass.classname == qx.core.Setting.get("qx.appearanceTheme")) {
+        this.setAppearanceTheme(vThemeClass.getInstance());
       }
     },
 
@@ -135,11 +136,6 @@
         qx.ui.core.ClientDocument.getInstance()._recursiveAppearanceThemeUpdate(propValue, propOldValue);
       }
 
-      // Reset cache
-      if (propValue) {
-        this.__cache = {};
-      }
-
       return true;
     },
 
@@ -148,97 +144,6 @@
 
     /*
     ---------------------------------------------------------------------------
-      THEME HELPER
-    ---------------------------------------------------------------------------
-    */
-
-    __cache : {},
-
-
-    /**
-     * Get the result of the "initial" function for a given id
-     *
-     * @type member
-     * @param theme {Object} appearance theme
-     * @param id {String} id of the apperance (e.g. "button", "label", ...)
-     * @return {Map} map of widget properties as returned by the "initial" function
-     */
-    styleFrom : function(id, states) {
-      return this.styleFromTheme(this.getAppearanceTheme(), id, states);
-    },
-
-
-    /**
-     * Get the result of the "state" function for a given id and states
-     *
-     * @type member
-     * @param theme {Object} appearance theme
-     * @param id {String} id of the apperance (e.g. "button", "label", ...)
-     * @param states {Map} hash map defining the set states
-     * @return {Map} map of widget properties as returned by the "state" function
-     */
-    styleFromTheme : function(theme, id, states)
-    {
-      var cache = this.__cache;
-      var entry = theme.appearances[id];
-
-      if (!entry) {
-        throw new Error("Missing appearance entry: " + id);
-      }
-
-      // Fast fallback to super entry
-      if (!entry.style && entry.extend) {
-        return this.styleFromTheme(theme, entry.extend, states);
-      }
-
-      // Creating cache-able ID
-      var helper = [];
-      for (var state in states)
-      {
-        if (states[state]) {
-          helper.push(state);
-        }
-      }
-      helper.sort().unshift(id);
-      var unique = helper.join(":");
-
-      // Using cache if available
-      if (cache[unique] !== undefined) {
-        return cache[unique];
-      }
-
-      // Otherwise "compile" the appearance
-      var ret;
-
-      // This is the place where we really call the appearance theme
-      if (entry.style)
-      {
-        // Executing appearance theme style definition
-        ret = entry.style(states);
-
-        // Fill with data from inheritance
-        if (entry.extend) {
-          qx.lang.Object.carefullyMergeWith(ret, this.styleFromTheme(theme, entry.extend, states));
-        }
-      }
-
-      // Normalize to null (needed for caching)
-      ret = ret || null;
-
-      // Cache new entry
-      cache[unique] = ret;
-
-      // Debug
-      // this.debug("Cached: " + qx.lang.Object.getLength(cache) + " :: " + unique);
-
-      return ret;
-    },
-
-
-
-
-    /*
-    ---------------------------------------------------------------------------
       DISPOSER
     ---------------------------------------------------------------------------
     */
@@ -255,8 +160,8 @@
         return;
       }
 
-      this.__cache = null;
-      this.__themes = null;
+      // Themes
+      this._appearanceThemes = null;
 
       return qx.manager.object.ObjectManager.prototype.dispose.call(this);
     }
@@ -271,7 +176,14 @@
   *****************************************************************************
   */
 
-  settings : {
+  settings :
+  {
+    /*
+    ---------------------------------------------------------------------------
+      DEFAULT SETTINGS
+    ---------------------------------------------------------------------------
+    */
+
     "qx.appearanceTheme" : "qx.theme.appearance.Classic"
   }
 });
Index: framework/source/class/qx/manager/object/ImageManager.js
===================================================================
--- framework/source/class/qx/manager/object/ImageManager.js	(Revision 6514)
+++ framework/source/class/qx/manager/object/ImageManager.js	(Arbeitskopie)
@@ -78,13 +78,15 @@
     iconTheme :
     {
       _legacy  : true,
-      type     : "object"
+      type     : "object",
+      instance : "qx.renderer.theme.IconTheme"
     },
 
     widgetTheme :
     {
       _legacy  : true,
-      type     : "object"
+      type     : "object",
+      instance : "qx.renderer.theme.WidgetTheme"
     }
   },
 
@@ -110,14 +112,14 @@
      *
      * @type member
      * @param vThemeClass {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     registerIconTheme : function(vThemeClass)
     {
-      this._iconThemes[vThemeClass.name] = vThemeClass;
+      this._iconThemes[vThemeClass.classname] = vThemeClass;
 
-      if (vThemeClass.name == qx.core.Setting.get("qx.iconTheme")) {
-        this.setIconTheme(vThemeClass);
+      if (vThemeClass.classname == qx.core.Setting.get("qx.iconTheme")) {
+        this.setIconTheme(vThemeClass.getInstance());
       }
     },
 
@@ -127,14 +129,14 @@
      *
      * @type member
      * @param vThemeClass {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     registerWidgetTheme : function(vThemeClass)
     {
-      this._widgetThemes[vThemeClass.name] = vThemeClass;
+      this._widgetThemes[vThemeClass.classname] = vThemeClass;
 
-      if (vThemeClass.name == qx.core.Setting.get("qx.widgetTheme")) {
-        this.setWidgetTheme(vThemeClass);
+      if (vThemeClass.classname == qx.core.Setting.get("qx.widgetTheme")) {
+        this.setWidgetTheme(vThemeClass.getInstance());
       }
     },
 
@@ -144,10 +146,10 @@
      *
      * @type member
      * @param vId {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     setIconThemeById : function(vId) {
-      this.setIconTheme(this._iconThemes[vId]);
+      this.setIconTheme(this._iconThemes[vId].getInstance());
     },
 
 
@@ -156,10 +158,10 @@
      *
      * @type member
      * @param vId {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     setWidgetThemeById : function(vId) {
-      this.setWidgetTheme(this._widgetThemes[vId]);
+      this.setWidgetTheme(this._widgetThemes[vId].getInstance());
     },
 
 
@@ -175,7 +177,7 @@
      * TODOC
      *
      * @type member
-     * @return {void}
+     * @return {void} 
      */
     _onaliaschange : function() {
       this._updateImages();
@@ -201,7 +203,7 @@
      */
     _modifyIconTheme : function(propValue, propOldValue, propData)
     {
-      propValue ? qx.manager.object.AliasManager.getInstance().add("icon", propValue.icons.uri) : qx.manager.object.AliasManager.getInstance().remove("icon");
+      propValue ? qx.manager.object.AliasManager.getInstance().add("icon", propValue.uri) : qx.manager.object.AliasManager.getInstance().remove("icon");
       return true;
     },
 
@@ -217,7 +219,7 @@
      */
     _modifyWidgetTheme : function(propValue, propOldValue, propData)
     {
-      propValue ? qx.manager.object.AliasManager.getInstance().add("widget", propValue.widgets.uri) : qx.manager.object.AliasManager.getInstance().remove("widget");
+      propValue ? qx.manager.object.AliasManager.getInstance().add("widget", propValue.uri) : qx.manager.object.AliasManager.getInstance().remove("widget");
       return true;
     },
 
@@ -320,7 +322,7 @@
      * @param vParent {var} TODOC
      * @param xCor {var} TODOC
      * @param yCor {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     createThemeList : function(vParent, xCor, yCor)
     {
@@ -332,8 +334,8 @@
 
       for (var vId in vThemes)
       {
-        var vObj = vThemes[vId];
-        var vButton = new qx.ui.form.Button(vPrefix + vObj.title, vIcon);
+        var vObj = vThemes[vId].getInstance();
+        var vButton = new qx.ui.form.Button(vPrefix + vObj.getTitle(), vIcon);
 
         vButton.setLocation(xCor, yCor);
         vButton.addEventListener(vEvent, new Function("qx.manager.object.ImageManager.getInstance().setIconThemeById('" + vId + "')"));
@@ -350,7 +352,7 @@
      *
      * @type member
      * @param vPath {var} TODOC
-     * @return {void}
+     * @return {void} 
      */
     preload : function(vPath) {
       qx.manager.object.ImagePreloaderManager.getInstance().create(qx.manager.object.AliasManager.getInstance().resolvePath(vPath));
@@ -403,12 +405,19 @@
   settings :
   {
     /*
+    ---------------------------------------------------------------------------
+      DEFAULT SETTINGS
+    ---------------------------------------------------------------------------
+    */
+
+    /*
       Make sure to select an icon theme that is compatible to the license you
       chose to receive the qooxdoo code under. For more information, please
       see the LICENSE file in the project's top-level directory.
      */
 
     "qx.iconTheme"   : "qx.theme.icon.Nuvola",
+
     "qx.widgetTheme" : "qx.theme.widget.Windows"
   }
 });
Index: framework/source/class/qx/ui/core/Widget.js
===================================================================
--- framework/source/class/qx/ui/core/Widget.js	(Revision 6514)
+++ framework/source/class/qx/ui/core/Widget.js	(Arbeitskopie)
@@ -21,8 +21,6 @@
 /* ************************************************************************
 
 #module(ui_core)
-#require(qx.core.Init)
-#require(qx.lang.Object)
 #use(qx.component.init.InterfaceInitComponent)
 #optional(qx.ui.core.Parent)
 #optional(qx.ui.form.Button)
@@ -79,7 +77,7 @@
     //   APPEARANCE
     // ************************************************************************
     this._states = {};
-    this._applyAppearance();
+    this._applyInitialAppearance();
   },
 
 
@@ -514,7 +512,7 @@
         {
           vWidget = vQueue[i];
 
-          vWidget._applyAppearance();
+          vWidget._applyStateAppearance();
 
           delete vWidget._isInGlobalStateQueue;
         }
@@ -3760,11 +3758,18 @@
           return this._computedWidthValue = this.getPreferredBoxWidth();
 
         case qx.ui.core.Widget.TYPE_FLEX:
-          if (this.getParent().getLayoutImpl().computeChildrenFlexWidth === undefined) {
-            throw new Error("Widget " + this + ": having horizontal flex size (width=" + this.getWidth() + ") but parent layout " + this.getParent() + " does not support it");
+          try {
+            this.getParent().getLayoutImpl().computeChildrenFlexWidth();
           }
+          catch(e)
+          {
+            if (this.getParent().getLayoutImpl()["computeChildrenFlexWidth"] == null) {
+              throw new Error("Widget " + this + ": having flex size but parent layout does not support it");
+            } else {
+              throw e;
+            }
+          }
 
-          this.getParent().getLayoutImpl().computeChildrenFlexWidth();
           return this._computedWidthValue = this._computedWidthFlexValue;
       }
 
@@ -3911,11 +3916,18 @@
           return this._computedHeightValue = this.getPreferredBoxHeight();
 
         case qx.ui.core.Widget.TYPE_FLEX:
-          if (this.getParent().getLayoutImpl().computeChildrenFlexHeight === undefined) {
-            throw new Error("Widget " + this + ": having vertical flex size (height=" + this.getHeight() + ") but parent layout " + this.getParent() + " does not support it");
+          try {
+            this.getParent().getLayoutImpl().computeChildrenFlexHeight();
           }
+          catch(e)
+          {
+            if (this.getParent().getLayoutImpl()["computeChildrenFlexHeight"] == null) {
+              throw new Error("Widget " + this + ": having flex size but parent layout does not support it");
+            } else {
+              throw e;
+            }
+          }
 
-          this.getParent().getLayoutImpl().computeChildrenFlexHeight();
           return this._computedHeightValue = this._computedHeightFlexValue;
       }
 
@@ -5238,8 +5250,36 @@
      * @type member
      * @return {void}
      */
-    _applyAppearance : function()
+    _applyInitialAppearance : function()
     {
+      var vAppearance = this.getAppearance();
+
+      if (vAppearance)
+      {
+        try
+        {
+          var r = qx.manager.object.AppearanceManager.getInstance().getAppearanceTheme().initialFrom(vAppearance);
+
+          if (r) {
+            this.set(r);
+          }
+        }
+        catch(ex)
+        {
+          this.error("Could not apply initial appearance", ex);
+        }
+      }
+    },
+
+
+    /**
+     * TODOC
+     *
+     * @type member
+     * @return {void}
+     */
+    _applyStateAppearance : function()
+    {
       // HACK: Is there a cleaner way to implement this?
       // Maybe not use the appearance for this, but a simple property and event handler combination?
       this._applyStateStyleFocus(this._states);
@@ -5250,7 +5290,7 @@
       {
         try
         {
-          var r = qx.manager.object.AppearanceManager.getInstance().styleFrom(vAppearance, this._states);
+          var r = qx.manager.object.AppearanceManager.getInstance().getAppearanceTheme().stateFrom(vAppearance, this._states);
 
           if (r) {
             this.set(r);
@@ -5278,16 +5318,15 @@
 
       if (vAppearance)
       {
-        var vAppearanceManager = qx.manager.object.AppearanceManager.getInstance();
+        var vOldAppearanceThemeObject = qx.manager.object.AppearanceManager.getInstance().getThemeById(vOldAppearanceTheme);
+        var vNewAppearanceThemeObject = qx.manager.object.AppearanceManager.getInstance().getThemeById(vNewAppearanceTheme);
 
-        var vOldAppearanceThemeObject = vAppearanceManager.getThemeById(vOldAppearanceTheme);
-        var vNewAppearanceThemeObject = vAppearanceManager.getThemeById(vNewAppearanceTheme);
+        var vOldAppearanceProperties = qx.lang.Object.mergeWith(vOldAppearanceThemeObject.initialFrom(vAppearance), vOldAppearanceThemeObject.stateFrom(vAppearance, this._states));
+        var vNewAppearanceProperties = qx.lang.Object.mergeWith(vNewAppearanceThemeObject.initialFrom(vAppearance), vNewAppearanceThemeObject.stateFrom(vAppearance, this._states));
 
-        var vOldAppearanceProperties = vAppearanceManager.styleFromTheme(vOldAppearanceThemeObject, vAppearance);
-        var vNewAppearanceProperties = vAppearanceManager.styleFromTheme(vNewAppearanceThemeObject, vAppearance);
-
         for (var vProp in vOldAppearanceProperties)
         {
+          // TODO: Access to private member (bad style) - please correct
           if (!(vProp in vNewAppearanceProperties)) {
             this[qx.core.LegacyProperty.getResetterName(vProp)]();
           }
@@ -5380,28 +5419,32 @@
      */
     _modifyAppearance : function(propValue, propOldValue, propData)
     {
-      var vAppearanceManager = qx.manager.object.AppearanceManager.getInstance();
+      var vAppearanceThemeObject = qx.manager.object.AppearanceManager.getInstance().getAppearanceTheme();
 
-      if (propValue)
-      {
-        var vNewAppearanceProperties = vAppearanceManager.styleFrom(propValue, this._states) || {};
+      var vNewAppearanceProperties = vAppearanceThemeObject.initialFrom(propValue);
+
+      if (this.isCreated()) {
+        qx.lang.Object.mergeWith(vNewAppearanceProperties, vAppearanceThemeObject.stateFrom(propValue, this._states));
       }
 
       if (propOldValue)
       {
-        var vOldAppearanceProperties = vAppearanceManager.styleFrom(propOldValue, this._states) || {};
+        var vOldAppearanceProperties = vAppearanceThemeObject.initialFrom(propOldValue);
 
+        if (this.isCreated()) {
+          qx.lang.Object.mergeWith(vOldAppearanceProperties, vAppearanceThemeObject.stateFrom(propOldValue, this._states));
+        }
+
         for (var vProp in vOldAppearanceProperties)
         {
+          // TODO: Access to private member (bad style) - please correct
           if (!(vProp in vNewAppearanceProperties)) {
             this[qx.core.LegacyProperty.getResetterName(vProp)]();
           }
         }
       }
 
-      if (vNewAppearanceProperties) {
-        this.set(vNewAppearanceProperties);
-      }
+      this.set(vNewAppearanceProperties);
 
       return true;
     },
@@ -7519,14 +7562,6 @@
   },
 
 
-
-
-  /*
-  *****************************************************************************
-     DEFER
-  *****************************************************************************
-  */
-
   defer : function(statics, members)
   {
     statics.__initApplyMethods(members);
@@ -7543,13 +7578,7 @@
             return;
           }
 
-          if (!(statics._globalWidgetQueue.length > 0 ||
-                statics._globalElementQueue.length > 0 ||
-                statics._globalStateQueue.length > 0 ||
-                statics._globalJobQueue.length > 0 ||
-                statics._globalLayoutQueue.length > 0 ||
-                statics._fastGlobalDisplayQueue.length > 0 ||
-                !qx.lang.Object.isEmpty(statics._lazyGlobalDisplayQueue))) {
+          if (!(qx.ui.core.Widget._globalWidgetQueue.length > 0 || qx.ui.core.Widget._globalElementQueue.length > 0 || qx.ui.core.Widget._globalStateQueue.length > 0 || qx.ui.core.Widget._globalJobQueue.length > 0 || qx.ui.core.Widget._globalLayoutQueue.length > 0 || qx.ui.core.Widget._fastGlobalDisplayQueue.length > 0 || !qx.lang.Object.isEmpty(qx.ui.core.Widget._lazyGlobalDisplayQueue))) {
             return;
           }
 
@@ -7559,10 +7588,10 @@
           var globalJobQueueLength = statics._globalJobQueue.length;
           var globalLayoutQueueLength = statics._globalLayoutQueue.length;
           var fastGlobalDisplayQueueLength = statics._fastGlobalDisplayQueue.length;
-          var lazyGlobalDisplayQueueLength = statics._lazyGlobalDisplayQueue ? statics._lazyGlobalDisplayQueue.length : 0;
+          var lazyGlobalDisplayQueueLength = statics._lazyGlobalDisplayQueue ? qx.ui.core.Widget._lazyGlobalDisplayQueue.length : 0;
 
           // Also used for inline event handling to seperate 'real' events
-          statics._inFlushGlobalQueues = true;
+          qx.ui.core.Widget._inFlushGlobalQueues = true;
 
           var vStart;
 
Index: framework/source/class/qx/ui/pageview/tabview/Button.js
===================================================================
--- framework/source/class/qx/ui/pageview/tabview/Button.js	(Revision 6514)
+++ framework/source/class/qx/ui/pageview/tabview/Button.js	(Arbeitskopie)
@@ -271,17 +271,14 @@
      * @type member
      * @return {void}
      */
-    _applyAppearance : function()
+    _applyStateAppearance : function()
     {
-      if (this.getView())
-      {
-        this._states.firstChild = this.isFirstVisibleChild();
-        this._states.lastChild = this.isLastVisibleChild();
-        this._states.alignLeft = this.getView().getAlignTabsToLeft();
-        this._states.barTop = this.getView().getPlaceBarOnTop();
-      }
+      this._states.firstChild = this.isFirstVisibleChild();
+      this._states.lastChild = this.isLastVisibleChild();
+      this._states.alignLeft = this.getView().getAlignTabsToLeft();
+      this._states.barTop = this.getView().getPlaceBarOnTop();
 
-      qx.ui.pageview.AbstractButton.prototype._applyAppearance.call(this);
+      qx.ui.pageview.AbstractButton.prototype._applyStateAppearance.call(this);
     },
 
 
Index: framework/source/class/qx/ui/pageview/buttonview/Bar.js
===================================================================
--- framework/source/class/qx/ui/pageview/buttonview/Bar.js	(Revision 6514)
+++ framework/source/class/qx/ui/pageview/buttonview/Bar.js	(Arbeitskopie)
@@ -56,7 +56,7 @@
     {
       _legacy      : true,
       type         : "string",
-      defaultValue : "button-view-bar"
+      defaultValue : "bar-view-bar"
     }
   },
 
@@ -113,19 +113,16 @@
      * @type member
      * @return {void}
      */
-    _applyAppearance : function()
+    _applyStateAppearance : function()
     {
-      if (this.getParent())
-      {
-        var vPos = this.getParent().getBarPosition();
+      var vPos = this.getParent().getBarPosition();
 
-        this._states.barLeft = vPos === "left";
-        this._states.barRight = vPos === "right";
-        this._states.barTop = vPos === "top";
-        this._states.barBottom = vPos === "bottom";
-      }
+      this._states.barLeft = vPos === "left";
+      this._states.barRight = vPos === "right";
+      this._states.barTop = vPos === "top";
+      this._states.barBottom = vPos === "bottom";
 
-      qx.ui.pageview.AbstractButton.prototype._applyAppearance.call(this);
+      qx.ui.pageview.AbstractButton.prototype._applyStateAppearance.call(this);
     }
   }
 });
Index: framework/source/class/qx/ui/pageview/buttonview/ButtonView.js
===================================================================
--- framework/source/class/qx/ui/pageview/buttonview/ButtonView.js	(Revision 6514)
+++ framework/source/class/qx/ui/pageview/buttonview/ButtonView.js	(Arbeitskopie)
@@ -79,7 +79,7 @@
     {
       _legacy      : true,
       type         : "string",
-      defaultValue : "button-view"
+      defaultValue : "bar-view"
     }
   },
 
Index: framework/source/class/qx/ui/pageview/buttonview/Button.js
===================================================================
--- framework/source/class/qx/ui/pageview/buttonview/Button.js	(Revision 6514)
+++ framework/source/class/qx/ui/pageview/buttonview/Button.js	(Arbeitskopie)
@@ -56,7 +56,7 @@
     {
       _legacy      : true,
       type         : "string",
-      defaultValue : "button-view-button"
+      defaultValue : "bar-view-button"
     }
   },
 
@@ -152,19 +152,16 @@
      * @type member
      * @return {void}
      */
-    _applyAppearance : function()
+    _applyStateAppearance : function()
     {
-      if (this.getView())
-      {
-        var vPos = this.getView().getBarPosition();
+      var vPos = this.getView().getBarPosition();
 
-        this._states.barLeft = vPos === "left";
-        this._states.barRight = vPos === "right";
-        this._states.barTop = vPos === "top";
-        this._states.barBottom = vPos === "bottom";
-      }
+      this._states.barLeft = vPos === "left";
+      this._states.barRight = vPos === "right";
+      this._states.barTop = vPos === "top";
+      this._states.barBottom = vPos === "bottom";
 
-      qx.ui.pageview.AbstractButton.prototype._applyAppearance.call(this);
+      qx.ui.pageview.AbstractButton.prototype._applyStateAppearance.call(this);
     }
   }
 });
Index: framework/source/class/qx/ui/pageview/buttonview/Page.js
===================================================================
--- framework/source/class/qx/ui/pageview/buttonview/Page.js	(Revision 6514)
+++ framework/source/class/qx/ui/pageview/buttonview/Page.js	(Arbeitskopie)
@@ -56,7 +56,7 @@
     {
       _legacy      : true,
       type         : "string",
-      defaultValue : "button-view-page"
+      defaultValue : "bar-view-page"
     }
   }
 });
Index: framework/source/class/qx/ui/pageview/buttonview/Pane.js
===================================================================
--- framework/source/class/qx/ui/pageview/buttonview/Pane.js	(Revision 6514)
+++ framework/source/class/qx/ui/pageview/buttonview/Pane.js	(Arbeitskopie)
@@ -56,7 +56,7 @@
     {
       _legacy      : true,
       type         : "string",
-      defaultValue : "button-view-pane"
+      defaultValue : "bar-view-pane"
     }
   },
 
@@ -83,16 +83,13 @@
      * @type member
      * @return {void}
      */
-    _applyAppearance : function()
+    _applyStateAppearance : function()
     {
-      if (this.getParent())
-      {
-        var vPos = this.getParent().getBarPosition();
+      var vPos = this.getParent().getBarPosition();
 
-        this._states.barHorizontal = vPos === "top" || vPos === "bottom";
-      }
+      this._states.barHorizontal = vPos === "top" || vPos === "bottom";
 
-      qx.ui.pageview.AbstractButton.prototype._applyAppearance.call(this);
+      qx.ui.pageview.AbstractButton.prototype._applyStateAppearance.call(this);
     }
   }
 });
Index: framework/source/class/qx/ui/pageview/AbstractButton.js
===================================================================
--- framework/source/class/qx/ui/pageview/AbstractButton.js	(Revision 6514)
+++ framework/source/class/qx/ui/pageview/AbstractButton.js	(Arbeitskopie)
@@ -134,10 +134,8 @@
      * @type member
      * @return {var} TODOC
      */
-    getView : function()
-    {
-      var pa = this.getParent();
-      return pa ? pa.getParent() : null;
+    getView : function() {
+      return this.getParent().getParent();
     },
 
 
